<?php

namespace FiloBlu\Rma\Plugin\Rma\Block\Returns;

use FiloBlu\Rma\Helper\ChangeSizeAttributeHelper;
use FiloBlu\Rma\Helper\RmaHelper;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\Registry;

class AfterCreate
{
    /**
     * @var RmaHelper
     */
    protected $rmaHelper;
    /**
     * @var ChangeSizeAttributeHelper
     */
    protected $changeSizeAttributeHelper;
    /**
     * @var Registry
     */
    protected $registry;

    public function __construct(
        RmaHelper $rmaHelper,
        ChangeSizeAttributeHelper $changeSizeAttributeHelper,
        Registry $registry
    )
    {
        $this->rmaHelper = $rmaHelper;
        $this->changeSizeAttributeHelper = $changeSizeAttributeHelper;
        $this->registry = $registry;
    }

    public function afterGetAttributes(\Magento\Rma\Block\Returns\Create $subject, $result)
    {
        $availableSizes = 0;

        $changeSize = $result['change_size'];
        $changeSizeOptions = $changeSize->getOptions();

        foreach ($changeSizeOptions as $changeSizeOption) {
            if (!$changeSizeOption->getValue()) {
                continue;
            }

            $availableSizes++;
        }

        $this->registry->register('fb_rma_must_show_change_size', $availableSizes);

        $resolution = $result['resolution'];

        $resolutionOptions = $resolution->getOptions();

        foreach ($resolutionOptions as $key => $resolutionOption) {
            if ($this->changeSizeAttributeHelper->getChangeSizeAttributeOptionId() == $resolutionOption->getValue()) {
                if (!$this->rmaHelper->checkIfAllowedMagentoChangeSizeReason($resolutionOption->getValue()) || !$availableSizes) {
                    unset($resolutionOptions[$key]);
                }
            }
        }

        $resolution->setOptions(array_values($resolutionOptions));


        $result['resolution'] = $resolution;

        return $result;
    }
}